#include < amxmodx >
#include < amxmisc >

#define _PLUGIN    "[RZ] VIP Core/Engine"
#define _VERSION           "1.0"
#define _AUTHOR         "H.RED.ZONE"

// For Bit Usage.
#define flag_get(%1,%2)            (%1 & (1 << (%2 & 31)))
#define flag_get_boolean(%1,%2)    (flag_get(%1,%2) ? true : false)
#define flag_set(%1,%2)            %1 |= (1 << (%2 & 31))
#define flag_unset(%1,%2)          %1 &= ~(1 << (%2 & 31))

// Bits For Marking User VIP.
new _bitPlayerIsVip

// This Will Be Called When Map Is Loaded.
public plugin_init( ) {
	
	// Register Plugin.
	register_plugin( _PLUGIN, _VERSION, _AUTHOR )
}

// Called On CFG Loading.
public plugin_cfg( ) {
	
	// New Directory.
	new _Directory[ 32 ]
	
	// Get Directory.
	get_configsdir( _Directory, charsmax(_Directory) )
	
	// Execute RZ VIP Config.
	server_cmd( "exec %s/rz_vip.cfg", _Directory )
}

// Plugins Natives Are Registered here.
public plugin_natives( ) {
	
	// Register Lybrary.
	register_library( "rz_vip_core" )
	
	// Register Native/s.
	register_native( "rz_is_user_vip", "native_core_is_vip" )
}

// Call This When Player Is put In Server.
public client_putinserver( plr ) {
	
	// If Player Is Connected.
	if( is_user_connected( plr ) ) {
		
		// Get his Flag.
		if( get_user_flags(plr) & ADMIN_LEVEL_H ) {
			
			// Set Him To Be VIP.
			flag_set( _bitPlayerIsVip, plr )
		} else {
			
			// Remove Him As VIP.
			flag_unset( _bitPlayerIsVip, plr )
		}
	}
}

// Player Disconnects.
public client_disconnect( plr ) {
	
	// Clear Player is Not Vip.
	flag_unset( _bitPlayerIsVip, plr )
}

// If Native "rz_is_user_vip" Is Called.
public native_core_is_vip( plugin_id, num_params ) {
	
	// Get Player ID
	new plr = get_param( 1 )
	
	// If Player Is Not Connected.
	if ( !is_user_connected( plr ) ) {
		
		// Log The Error Message.
		log_error( AMX_ERR_NATIVE, "[RZ] Invalid Player (%d)", plr )
		return -1
	}
	
	// Return If He Is Vip Or If He Is Not.
	return flag_get_boolean( _bitPlayerIsVip, plr )
}
