#include < amxmodx >
	#include < rz_vip_core >

#define _PLUGIN        "[RZ] VIP Message"
#define _VERSION             "1.0"
#define _AUTHOR           "H.RED.ZONE"

// Cvars.
new _pCvarVipShowConnect
	,_pCvarChatPrefix

// Text And MaxPlayers.
new g_MsgSayText
	,g_MaxPlayers	
	
// This Will Be Called When Map Is Loaded.
public plugin_init() {
	
	// Register Plugin.
	register_plugin( _PLUGIN, _VERSION, _AUTHOR )
	
	// Cvars.
	_pCvarVipShowConnect = register_cvar( "rz_vip_connect_show", "1" )
	_pCvarChatPrefix = register_cvar( "rz_vip_prefix_text", "ZP", 0, 0.0 )
	
	// Text And MaxPlayers.
	g_MsgSayText = get_user_msgid("SayText");
	g_MaxPlayers = get_maxplayers()
	
}

// Call This When Player Is put In Server.
public client_putinserver(plr) {
	
	//If Cvars Is ON.
	if( get_pcvar_num(_pCvarVipShowConnect) == 1 ) {
		
		// If Is User VIP.
		if(rz_is_user_vip(plr)) {
		
			// Set task 
			set_task(5.0,"vip_connected", plr)
		}
	}
}

// Vip Task Player Connected.
public vip_connected( plr ) {
	
	// Get His Name.
	new name[32]
	get_user_name( plr, name, 31 )
	
	// Write Message.
	ProtoChat(plr, "VIP^x04 %s^x01 connected to server.",name )
}

// My Proto Chat.
ProtoChat ( plr, const sFormat[], any:... ) {
	
	static i; i = plr ? plr : get_player()
	
	if ( !i ) {
		return PLUGIN_HANDLED;
	}
	
	new sPrefix[ 16 ]
	get_pcvar_string( _pCvarChatPrefix, sPrefix, 15 )
	
	new sMessage[256];
	new len = formatex( sMessage, 255, "^x01[^x04%s^x01] ", sPrefix )
	vformat( sMessage[len], 255-len, sFormat, 3 )
	sMessage[ 192 ] = '^0' 
	
	Make_SayText( plr, i, sMessage )
	
	return PLUGIN_CONTINUE;
}

// Get Player.
get_player() {
	
	// Loop Players.
	for ( new plr; plr <= g_MaxPlayers; plr++) {
		
		// If Player is connected.
		if ( is_user_connected(plr) ) {
			
			// Return.
			return plr
		}
	}
	
	// Return Plugin Handled.
	return PLUGIN_HANDLED
}

// Make Text.
Make_SayText( Receiver, Sender, sMessage[] ) {
	
	if (!Sender) {
		
		return PLUGIN_HANDLED;
	}
	
	message_begin(Receiver ? MSG_ONE_UNRELIABLE : MSG_ALL, g_MsgSayText, {0,0,0}, Receiver)
	write_byte(Sender)
	write_string(sMessage)
	message_end()
	
	return PLUGIN_CONTINUE;
}
