#include < amxmodx >
#include < hamsandwich >
#include < fakemeta >
#include < zp50_core >
	#include < rz_vip_core >

#define _PLUGIN        "[RZ] VIP MultiJump"
#define _VERSION              "1.0"
#define _AUTHOR            "H.RED.ZONE"

// Jump Count.
new _gJumpCount[33]

//Cvars.
new _pCvarVipMultiJumpAmount
	,_pCvarVipMultiJumpZombie
	,_pCvarVipMultiJumpHuman

// This Will Be Called When Map Is Loaded.
public plugin_init() {
	
	// Register Plugin.
	register_plugin( _PLUGIN, _VERSION, _AUTHOR )
	
	// Cvars.
	_pCvarVipMultiJumpAmount = register_cvar( "rz_vip_multijump_amount", "1" )
	_pCvarVipMultiJumpZombie = register_cvar( "rz_vip_multijump_zombie", "1" )
	_pCvarVipMultiJumpHuman = register_cvar( "rz_vip_multijump_human", "1" )
	
	// Register Ham.
	RegisterHam( Ham_Player_Jump, "player", "_FW_Player_Jump", 0 )
}

// Called When Player Jumps. (Credits To Connor)
public _FW_Player_Jump( plr ) {
	
	// If Is User Alive.
	if( is_user_alive(plr) 
	
	// And If User Is VIP.
	&& rz_is_user_vip(plr) ) {
		
		// Pev Flags.
		new Flags = pev( plr, pev_flags )
		
		// If User Jumps Out Of The Water.
		if( Flags & FL_WATERJUMP 
		
		// Or If Water Level Is 2 Or More (Submerged).
		|| pev(plr, pev_waterlevel) >= 2 
		
		// If Button Not Pressed.
		|| !(get_pdata_int(plr, 246) & IN_JUMP) ){
			
			// Return Ham Ignore.
			return HAM_IGNORED
		}
		
		// If User Is Zombie.
		if( zp_core_is_zombie(plr) 
		
		// If Cvar Is 0.
		&& get_pcvar_num(_pCvarVipMultiJumpZombie) == 0) {
			
			// Return Ham Ignore.
			return HAM_IGNORED
		}
		
		// If User Is Not Zombie.
		if( !zp_core_is_zombie(plr) 
		
		// If Cvar Is 0.
		&& get_pcvar_num(_pCvarVipMultiJumpHuman) == 0) {
			
			return HAM_IGNORED
		}
		
		// If User Is On The Ground.
		if( Flags & FL_ONGROUND ) {
			
			// Jump Count Is Set To 0
			_gJumpCount[ plr ] = 0
			
			// Return Ham Ignore.
			return HAM_IGNORED
		}
		
		// Cvar For Jumps.
		new Multi = get_pcvar_num( _pCvarVipMultiJumpAmount )

		// If Multijump Is On.
		if( Multi ) {
			
			// If Private Data From Fall Velocity Is Lower Then 500.
			if( get_pdata_float(plr, 251) < 500
			
			// And Jump Counte Added Lower Or Same As Multi Jump Count.
			&& ++_gJumpCount[plr] <= Multi ) {
				
				// Set Velocity. 
				new Float:fVelocity[ 3 ]
				pev( plr, pev_velocity, fVelocity )
				fVelocity[ 2 ] = 268.328157
				set_pev( plr, pev_velocity, fVelocity )
				
				// Return Ham Ignore.
				return HAM_HANDLED
			}
		}
	}
	
	// Return Ham Ignore.
	return HAM_IGNORED
}
