#include < amxmodx >
#include < hamsandwich >
#include < zp50_core >
#include < zp50_ammopacks >
	#include < rz_vip_core >

#define _PLUGIN      "[RZ] VIP Ammopacks"
#define _VERSION            "1.0"
#define _AUTHOR          "H.RED.ZONE"

// Cvars.
new _pCvarVipDmgAmmopacks
	,_pCvarVipDmgRewardOn
	
// We Will Count Damage Done So We Can Give Rewards Later.
new Float: _gDamageCount[33]

// This Will Be Called When Map Is Loaded.
public plugin_init( ) {
	
	// Register Plugin.
	register_plugin( _PLUGIN, _VERSION, _AUTHOR )
	
	// Ham Player Take Damage.
	RegisterHam( Ham_TakeDamage, "player", "_FwPlayerTakeDamage" )
	
	// Cvars.
	_pCvarVipDmgRewardOn = register_cvar( "rz_vip_dmg_reward_on", "1" )
	_pCvarVipDmgAmmopacks = register_cvar( "rz_vip_dmg_reward_amount", "400" )
}

// Called When Player Connects.
public client_connect( plr ) {
	
	// Set Damage Count To Zero.
	_gDamageCount[ plr ] = 0.0
}

// Called When Player Disconnects.
public client_disconnect( plr ) {
	
	// Set Damage Count To Zero.
	_gDamageCount[ plr ] = 0.0
}

// Ham Forward When taking Damage.
public _FwPlayerTakeDamage( Victim, Inflictor, Attacker, Float:Damage, Damage_type ) {
	
	// If Attacker Is Alive.
	if( is_user_alive(Attacker) ) {
		
		// If Attacker Is VIP.
		if( rz_is_user_vip(Attacker)
		
		// And If Cvar Is Set On 1.
		&& get_pcvar_num(_pCvarVipDmgRewardOn) == 1 ) {
				
			// If Vip Damage Reward Cvar Is Or Is Above Zero.
			if( get_pcvar_num(_pCvarVipDmgAmmopacks) >= 0 ) {
				
				// We Add To Count Damage We Deal.
				_gDamageCount[ Attacker ] += Damage
				
				// If Damage Count Is Bigger Then Reqested Damage In Cvar.
				if( _gDamageCount[Attacker] > get_pcvar_float(_pCvarVipDmgAmmopacks) ) {
					
					// We Set Players AmmoPacks.
					zp_ammopacks_set( Attacker, zp_ammopacks_get(Attacker) +1 )
					
					// Return Count To Previous Settings.
					_gDamageCount[Attacker] -= get_pcvar_float(_pCvarVipDmgAmmopacks)
					
					// Rest Ignore.
					return HAM_IGNORED
				}	
			}
		}
	}
	// Ham Ignore.
	return HAM_IGNORED
}
